<?php


/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class EventosFaltasIntervalo{

    private $_evento;
    private $_calculo_folha;
    private $_item_calculo_fonte;


    /**
     * Construtor.
     *
     * @param integer $nrOrg       Numero da Org. Trabalho.
     * @param integer $nrOrgPadrao Nunero da Org. Padrao.
     */
    public function __construct($nrOrg, $nrOrgPadrao){
        $this->_evento = new FpaeventomEntity(null, $nrOrg, $nrOrgPadrao);
        $this->_calculo_folha_fonte = new FpacalculofolhaEntity;
        $this->_itens_calculo_fonte = new FpaitecalcfolhaEntity;
    }


    /**
     * Enter description here ...
     *
     * @param GpevinculomEntity $vinculo              Vinculo.
     * @param TkDateTime        $dt_inicial           Data Inicial.
     * @param TkDateTime        $dt_final             Data Final.
     * @param integer           $nrTipoModalidadeCalc Numero do Tipo de Modalidade de Calculo.
     * @param integer           $nrOcorrenciaCalc     Numero de Ocorrencia de Calculo.
     *
     * @return void|Ambigous <void, multitype:>
     *
     * @author alessandrobartels
     *         alessandrobartels - 13/02/2012 - Parametrizado $nrTipoModalidadeCalc, $nrOcorrenciaCalc.
     */
    public function calcula(
        GpevinculomEntity $vinculo, TkDateTime $dt_inicial, TkDateTime $dt_final, $nrTipoModalidadeCalc,
        $nrOcorrenciaCalc, $nrOrgPadrao
    ){

        if ($divisor === null) {
            $dt = new TkDateTime($dt_inicial, TkDateTime::FORMAT_DATE);
            // Rever: $divisor = FpaDate::Months($dt_inicial, $dt_final); .
            $divisor = $dt->months($dt_final);
        }

        /*BORBA 28/11/2014 Atendendo a solicitação 155226,*/
        /*Quando o vínculo é admitido e demitido dentro do mesmo mês e existem faltas nem sempre a dtadmissao é no dia primeiro
          e não coincide com a data de competencia do Calculo de folha*/
        if (is_object($dt_inicial)) {
            $dt_inicial->setDay(1);		
		}
        
        $lista_nr_calculo_folha = $this->_calculo_folha_fonte->retornaCalculoFolhaPeriodo(
            $vinculo->getNrorg(), FpatipomovimentEntity::TP_MOV_MENSAL, $dt_inicial, $dt_final, $nrTipoModalidadeCalc,
            $nrOcorrenciaCalc
        );

        $lista_nr_eventos = $this->_evento->retornaListaEventoFalta($vinculo->getNrorg(), $nrOrgPadrao);
        if (empty($lista_nr_eventos) === false) {
            $lista_eventos  = $this->_itens_calculo_fonte->totalizaItensHistorico(
                $vinculo, $lista_nr_calculo_folha, $lista_nr_eventos
            );
            return $lista_eventos;
        } else {
            return;
        }
    }


}