/* Sistemas Integrados TECNISA

Nome: 9806_CDPTRGO_LOG_CDP_PERDAETAPA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela PERDAETAPA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              PERDAETAPA, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_PERDAETAPA
AFTER DELETE OR INSERT OR UPDATE
ON PERDAETAPA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :NEW.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF :NEW.NRPERDAETA IS NOT NULL THEN
         V_DESC := V_DESC || 'NrPerdaEtapa= '  || NVL(:NEW.NRPERDAETA,'') || ' ';
         END IF;  

         IF :NEW.CDPRODPERDA IS NOT NULL THEN 
            V_DESC := V_DESC || 'CdProdPerda= '   || :NEW.CDPRODPERDA || ' ';
         END IF;
         
         IF :NEW.CDEQUIPPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEquipaProd= '  || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF :NEW.CDTIPOPERDA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoPerda= '   || :NEW.CDTIPOPERDA || ' ';
         END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.NRPERDAETA;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF (:NEW.CDETAPAPROD <> :OLD.CDETAPAPROD) THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF (:NEW.NRPERDAETA <> :OLD.NRPERDAETA) THEN
         V_DESC := V_DESC || 'NrPerdaEtapa= '  || NVL(:NEW.NRPERDAETA,'') || ' ';
         END IF;  

         IF (:NEW.CDPRODPERDA <> :OLD.CDPRODPERDA) THEN 
            V_DESC := V_DESC || 'CdProdPerda= '   || :NEW.CDPRODPERDA || ' ';
         END IF;
         
         IF (NVL(:NEW.CDEQUIPPRO,'-1') <> NVL(:OLD.CDEQUIPPRO,'-1')) THEN
            V_DESC := V_DESC || 'CdEquipaProd= '  || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF (NVL(:NEW.CDTIPOPERDA,'-1') <> NVL(:OLD.CDTIPOPERDA,'-1')) THEN
            V_DESC := V_DESC || 'CdTipoPerda= '   || :NEW.CDTIPOPERDA || ' ';
         END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.NRPERDAETA;

          V_IDTIPOOPER := '2';    
          V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:OLD.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :OLD.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:OLD.CDETAPAPROD,'') || ' ';
         END IF;

         IF :OLD.NRPERDAETA IS NOT NULL THEN
         V_DESC := V_DESC || 'NrPerdaEtapa= '  || NVL(:OLD.NRPERDAETA,'') || ' ';
         END IF;  

         IF :OLD.CDPRODPERDA IS NOT NULL THEN 
            V_DESC := V_DESC || 'CdProdPerda= '   || :OLD.CDPRODPERDA || ' ';
         END IF;
         
         IF :OLD.CDEQUIPPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEquipaProd= '  || :OLD.CDEQUIPPRO || ' ';
         END IF;

         IF :OLD.CDTIPOPERDA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoPerda= '   || :OLD.CDTIPOPERDA || ' ';
         END IF;
         
      V_ITPESQ := :OLD.CDFILIAL   || :OLD.CDPRODUTO   || :OLD.CDPROCFABRIC || :OLD.CDETAPAPROD ||
                  :OLD.NRPERDAETA;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;   

   IF NOT (V_DESC IS NULL) THEN
      
      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                   VALUES  ('PERDAETAPA', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);    
                             
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_PERDAETAPA','5.07.001'); END;
/    
