const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../json/leitorJson.po');
const tipoAjustePagarPage = require('../../../../page-objects/parametrizacao/financeiro/titulosAPagar/tipoAjusteDeTituloPagar.po.js');
const ajusteGridId = '34206422733847517932080';

describe('Tela Tipo de Ajuste de Título a Pagar', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		tipoAjustePagarPage.abrir();
		geral.clickAplicarFiltro();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${ajusteGridId}`)));
	});

	afterEach(() => {
		geral.sair();
	});

	it('Acessar a tela Tipo de Ajuste de Título a Pagar', () => {
		expect(z.component.header.getTitle())
			.toBe('Tipo de Ajuste de Título a Pagar');
	});

	it('Adicionar um tipo de ajuste', () => {
		geral.clickAdicionar();
		tipoAjustePagarPage.adicionar(j.getValor('codigoAjuste'),
			j.getValor('descricaoAjuste'), 'Acrescer', j.getValor('contaContabil'),
			j.getValor('historicoPadrao'), 'Normal', 'Sim');
		geral.clickSalvar();

		expect(geral.gridHasText(ajusteGridId, j.getValor('descricaoAjuste'), 1))
			.toBe(j.getValor('descricaoAjuste'));
		expect(geral.gridHasText(ajusteGridId, j.getValor('codigoAjuste')))
			.toBe(j.getValor('codigoAjuste'));
	});

	it('Editar registro', () => {
		geral.clickGrid('CDAJUCTREC', j.getValor('codigoAjuste'), ajusteGridId);
		geral.clickEditar();
		tipoAjustePagarPage.editar(j.getValor('descricaoAjuste1'),
			j.getValor('contaContabil1'), j.getValor('historicoPadrao1'));
		geral.clickSalvar();

		expect(geral.gridHasText(ajusteGridId, j.getValor('descricaoAjuste1'), 1))
			.toBe(j.getValor('descricaoAjuste1'));
		expect(geral.gridHasText(ajusteGridId, j.getValor('codigoAjuste1')))
			.toBe(j.getValor('codigoAjuste1'));
	});

	it('Excluir tipo de ajuste adicionado', () => {
		geral.clickGrid('CDAJUCTREC', j.getValor('codigoAjuste1'), ajusteGridId);
		geral.clickExcluir();
		geral.clickSim();

		expect(geral.gridHasText(ajusteGridId, j.getValor('descricaoAjuste1'), 1))
			.toBeUndefined();
		expect(geral.gridHasText(ajusteGridId, j.getValor('codigoAjuste1')))
			.toBeUndefined();
	});
});
